Add Python scripting to GDB.
[coreboot.git] / util / crossgcc / buildgcc
1 #!/bin/sh
2 #
3 # Copyright (C) 2008-2010 by coresystems GmbH
4 # written by Patrick Georgi <patrick.georgi@coresystems.de> and
5 #            Stefan Reinauer <stefan.reinauer@coresystems.de>
6 #
7 # Copyright (C) 2011 by Sage Electronic Engineering
8 #
9 # This program is free software; you can redistribute it and/or modify
10 # it under the terms of the GNU General Public License as published by
11 # the Free Software Foundation; version 2 of the License.
12 #
13 # This program is distributed in the hope that it will be useful,
14 # but WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the GNU General Public License
19 # along with this program; if not, write to the Free Software
20 # Foundation, Inc., 51 Franklin Street, Suite 500, Boston, MA  02110-1335, USA
21 #
22
23 CROSSGCC_DATE="November 1st, 2011"
24 CROSSGCC_VERSION="1.06"
25
26 # default settings
27 TARGETDIR=`pwd`/xgcc
28 TARGETARCH=i386-elf
29 DESTDIR=
30
31 # version numbers
32 GMP_VERSION=5.0.2
33 MPFR_VERSION=3.1.0
34 MPC_VERSION=0.9
35 LIBELF_VERSION=0.8.13
36 GCC_VERSION=4.6.1
37 GCC_AUTOCONF_VERSION=2.64
38 BINUTILS_VERSION=2.21.1
39 GDB_VERSION=7.3.1
40 W32API_VERSION=3.17-2
41 W32API_VERSION_SHORT=3.17
42 MINGWRT_VERSION=3.18
43 IASL_VERSION=20110922
44 PYTHON_VERSION=2.7.2
45 EXPAT_VERSION=2.0.1
46
47 # archive locations
48 GMP_ARCHIVE="ftp://ftp.gmplib.org/pub/gmp-${GMP_VERSION}/gmp-${GMP_VERSION}.tar.bz2"
49 MPFR_ARCHIVE="http://www.mpfr.org/mpfr-${MPFR_VERSION}/mpfr-${MPFR_VERSION}.tar.bz2"
50 MPC_ARCHIVE="http://www.multiprecision.org/mpc/download/mpc-${MPC_VERSION}.tar.gz"
51 LIBELF_ARCHIVE="http://www.mr511.de/software/libelf-${LIBELF_VERSION}.tar.gz"
52 GCC_ARCHIVE="ftp://ftp.fu-berlin.de/unix/languages/gcc/releases/gcc-${GCC_VERSION}/gcc-core-${GCC_VERSION}.tar.bz2"
53 BINUTILS_ARCHIVE="http://ftp.gnu.org/gnu/binutils/binutils-${BINUTILS_VERSION}.tar.bz2"
54 GDB_ARCHIVE="http://ftp.gnu.org/gnu/gdb/gdb-${GDB_VERSION}.tar.bz2"
55 W32API_ARCHIVE="http://downloads.sourceforge.net/project/mingw/MinGW/BaseSystem/RuntimeLibrary/Win32-API/w32api-${W32API_VERSION_SHORT}/w32api-${W32API_VERSION}-mingw32-src.tar.lzma"
56 MINGWRT_ARCHIVE="http://downloads.sourceforge.net/project/mingw/MinGW/BaseSystem/RuntimeLibrary/MinGW-RT/mingwrt-${MINGWRT_VERSION}/mingwrt-${MINGWRT_VERSION}-mingw32-src.tar.gz"
57 IASL_ARCHIVE="http://www.acpica.org/download/acpica-unix-${IASL_VERSION}.tar.gz"
58 PYTHON_ARCHIVE="http://www.python.org/ftp/python/${PYTHON_VERSION}/Python-${PYTHON_VERSION}.tar.bz2"
59 EXPAT_ARCHIVE="http://downloads.sourceforge.net/sourceforge/expat/expat-${EXPAT_VERSION}.tar.gz"
60
61 GMP_DIR="gmp-${GMP_VERSION}"
62 MPFR_DIR="mpfr-${MPFR_VERSION}"
63 MPC_DIR="mpc-${MPC_VERSION}"
64 LIBELF_DIR="libelf-${LIBELF_VERSION}"
65 GCC_DIR="gcc-${GCC_VERSION}"
66 BINUTILS_DIR="binutils-${BINUTILS_VERSION}"
67 GDB_DIR="gdb-${GDB_VERSION}"
68 W32API_DIR="w32api-${W32API_VERSION}-mingw32"
69 MINGWRT_DIR="mingwrt-${MINGWRT_VERSION}-mingw32"
70 IASL_DIR="acpica-unix-${IASL_VERSION}"
71 PYTHON_DIR="Python-${PYTHON_VERSION}"
72 EXPAT_DIR="expat-${EXPAT_VERSION}"
73
74 SAVETEMPS=0
75 SKIPGDB=1
76 SKIPPYTHON=1
77
78 red='\033[0;31m'
79 RED='\033[1;31m'
80 green='\033[0;32m'
81 GREEN='\033[1;32m'
82 blue='\033[0;34m'
83 BLUE='\033[1;34m'
84 cyan='\033[0;36m'
85 CYAN='\033[1;36m'
86 NC='\033[0m' # No Color
87
88 searchgnu()
89 {
90         # $1 short name
91         # result: GNU version of that tool on stdout
92         #         or no output if no GNU version was found
93         for i in "$1" "g$1" "gnu$1"; do
94                 if test -x "`which $i 2>/dev/null`"; then
95                         if test `$i --version 2>/dev/null |grep -c GNU` \
96                             -gt 0; then
97                                 echo $i
98                                 return
99                         fi
100                 fi
101         done
102         printf "${RED}ERROR:${red} Missing toolchain: $1${NC}\n" >&2
103         exit 1
104 }
105
106 TAR=`searchgnu tar` || exit $?
107 PATCH=`searchgnu patch` || exit $?
108 MAKE=`searchgnu make` || exit $?
109
110 cleanup()
111 {
112         printf "Cleaning up temporary files... "
113         rm -rf build-* combined gcc-* gmp-* mpfr-* mpc-* libelf-* binutils-*
114         rm -rf gdb-* w32api-* mingwrt-* acpica-* python-* expat-*
115         printf "${green}ok${NC}\n"
116 }
117
118 myhelp()
119 {
120         printf "Usage: $0 [-V] [-c] [-p <platform>] [-d <target directory>] [-D <dest dir>] [-G] [-S]\n"
121         printf "       $0 [-V|--version]\n"
122         printf "       $0 [-h|--help]\n\n"
123
124         printf "Options:\n"
125         printf "    [-V|--version]                print version number and exit\n"
126         printf "    [-h|--help]                   print this help and exit\n"
127         printf "    [-c|--clean]                  remove temporary files before build\n"
128         printf "    [-t|--savetemps]              don't remove temporary files after build\n"
129         printf "    [-j|--jobs <num>]             run <num> jobs in parallel in make\n"
130         printf "    [-p|--platform <platform>]    target platform to build cross compiler for\n"
131         printf "                                  (defaults to $TARGETARCH)\n"
132         printf "    [-d|--directory <target dir>] target directory to install cross compiler to\n"
133         printf "                                  (defaults to $TARGETDIR)\n\n"
134         printf "    [-D|--destdir <dest dir>]     destination directory to install cross compiler to\n"
135         printf "                                  (for RPM builds, default unset)\n"
136         printf "    [-G|--gdb]                    build GNU debugger\n"
137         printf "    [-S|--scripting]              build scripting support for GDB\n\n"
138 }
139
140 myversion()
141 {
142         # version tag is always printed, so just print the license here
143
144         cat << EOF
145 Copyright (C) 2008-2010 by coresystems GmbH
146 Copyright (C) 2011 by Sage Electronic Engineering
147
148 This program is free software; you can redistribute it and/or modify
149 it under the terms of the GNU General Public License as published by
150 the Free Software Foundation; version 2 of the License.
151
152 This program is distributed in the hope that it will be useful,
153 but WITHOUT ANY WARRANTY; without even the implied warranty of
154 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
155 GNU General Public License for more details.
156
157 EOF
158 }
159
160 printf "${blue}Welcome to the ${red}coreboot${blue} cross toolchain builder v$CROSSGCC_VERSION ($CROSSGCC_DATE)${NC}\n\n"
161
162 # Look if we have getopt. If not, build it.
163 export PATH=$PATH:.
164 getopt - > /dev/null 2>/dev/null || gcc -o getopt getopt.c
165
166 # parse parameters.. try to find out whether we're running GNU getopt
167 getoptbrand="`getopt -V | sed -e '1!d' -e 's,^\(......\).*,\1,'`"
168 if [ "${getoptbrand}" = "getopt" ]; then
169         # Detected GNU getopt that supports long options.
170         args=`getopt -l version,help,clean,directory:,platform:,jobs:,destdir:,savetemps,skip-gdb Vhcd:p:j:D:tG -- "$@"`
171         eval set "$args"
172 else
173         # Detected non-GNU getopt
174         args=`getopt Vhcd:p:j:D:tG $*`
175         set -- $args
176 fi
177
178 if [ $? != 0 ]; then
179         myhelp
180         exit 1
181 fi
182
183 while true ; do
184         case "$1" in
185                 -V|--version)   shift; myversion; exit 0;;
186                 -h|--help)      shift; myhelp; exit 0;;
187                 -c|--clean)     shift; cleanup;;
188                 -t|--savetemps) shift; SAVETEMPS=1;;
189                 -d|--directory) shift; TARGETDIR="$1"; shift;;
190                 -p|--platform)  shift; TARGETARCH="$1"; shift;;
191                 -D|--destdir)   shift; DESTDIR="$1"; shift;;
192                 -j|--jobs)      shift; JOBS="-j $1"; shift;;
193                 -G|--gdb)       shift; SKIPGDB=0;;
194                 -S|--scripting) shift; SKIPPYTHON=0;;
195                 --)             shift; break;;
196                 -*)             printf "Invalid option\n\n"; myhelp; exit 1;;
197                 *)              break;;
198         esac
199 done
200
201 GDB_PACKAGE="GDB"
202 PYTHON_PACKAGE="PYTHON"
203 EXPAT_PACKAGE="EXPAT"
204 if [ $SKIPGDB -eq 1 ]; then
205         printf "Will skip GDB ... ${green}ok${NC}\n"
206         GDB_ARCHIVE=""
207         GDB_PACKAGE=""
208         if [ $SKIPPYTHON -eq 0 ]; then
209                 printf "Python scripting needs GDB ... disabling ... ${green}ok${NC}\n"
210                 SKIPPYTHON=1
211         fi
212 fi
213 if [ $SKIPPYTHON -eq 1 ]; then
214         PYTHON_PACKAGE=""
215         EXPAT_PACKAGE=""
216 fi
217
218 MINGW_ARCHIVES=""
219 if [ "$TARGETARCH" = "i386-mingw32" ]; then
220         MINGW_ARCHIVES="$W32API_ARCHIVE $MINGWRT_ARCHIVE"
221 fi
222
223 # coreboot does not like the GOLD linker
224 # USE_GOLD="--enable-gold"
225 USE_GOLD=""
226 GCC_OPTIONS="--enable-lto"
227
228 if [ ${GCC_VERSION} = "4.6.2" ]; then
229   if [ ! -r tarballs/gcc-core-${GCC_VERSION}.tar.bz2 ]; then
230     printf "Pre-Release GCC ${GCC_VERSION}, checking out subversion trunk\n"
231     mkdir -p tarballs/.tmp
232     cd tarballs/.tmp
233     rm -rf gcc-${GCC_VERSION}
234     svn export -q svn://gcc.gnu.org/svn/gcc/trunk gcc-${GCC_VERSION}
235     printf "done. Now creating tar ball...\n"
236     tar cjf ../gcc-core-${GCC_VERSION}.tar.bz2 gcc-${GCC_VERSION}
237     printf "done. Now cleaning up...\n"
238     cd ..
239     rm -rf .tmp
240     cd ..
241     printf "done.\n"
242   fi
243 fi
244
245 printf "Downloading tar balls ... \n"
246 mkdir -p tarballs
247 for ARCHIVE in $GMP_ARCHIVE $MPFR_ARCHIVE $MPC_ARCHIVE $LIBELF_ARCHIVE  \
248             $GCC_ARCHIVE $BINUTILS_ARCHIVE $GDB_ARCHIVE $MINGW_ARCHIVES \
249             $IASL_ARCHIVE $PYTHON_ARCHIVE $EXPAT_ARCHIVE; do
250         FILE=`basename $ARCHIVE`
251         printf " * $FILE "
252         test -f tarballs/$FILE && printf "(cached)" || (
253                 printf "(downloading)"
254                 cd tarballs
255                 wget -q $ARCHIVE
256         )
257         test -f tarballs/$FILE || \
258                 printf "\n${RED}Failed to download $FILE.${red}\n"
259         test -f tarballs/$FILE || exit 1
260         printf "\n"
261 done
262 printf "Downloaded tar balls ... "
263 printf "${green}ok${NC}\n"
264
265 MINGW_PACKAGES=""
266 if [ "$TARGETARCH" = "i386-mingw32" ]; then
267         MINGW_PACKAGES="W32API MINGWRT"
268 fi
269
270 printf "Unpacking and patching ... \n"
271 for PACKAGE in GMP MPFR MPC LIBELF GCC BINUTILS $PYTHON_PACKAGE \
272             $EXPAT_PACKAGE $GDB_PACKAGE $MINGW_PACKAGES IASL; do
273         archive=$PACKAGE"_ARCHIVE"
274         archive="`eval echo '$'$archive`"
275         dir=$PACKAGE"_DIR"
276         dir="`eval echo '$'${dir}`"
277         test -d ${dir} || (
278                 printf " * `basename $archive`\n"
279                 FLAGS=zxf
280                 suffix=`echo $archive | sed 's,.*\.,,'`
281                 test "$suffix" = "gz" && FLAGS=zxf
282                 test "$suffix" = "bz2" && FLAGS=jxf
283                 test "$suffix" = "lzma" && FLAGS="--lzma -xf"
284                 $TAR $FLAGS tarballs/`basename $archive`
285                 for patch in patches/${dir}_*.patch; do
286                         test -r $patch || continue
287                         printf "   o `basename $patch`\n"
288                         $PATCH -s -N -p0 < `echo $patch` || \
289                                 printf "\n${RED}Failed $patch.${red}\n"
290                 done
291         )
292 done
293 printf "Unpacked and patched ... "
294 printf "${green}ok${NC}\n"
295
296 if [ "$TARGETARCH" = "i386-mingw32" ]; then
297         mkdir -p $TARGETDIR/i386-mingw32/sys-include
298         mv $MINGWRT_DIR/include/* $W32API_DIR/include/* \
299                                   $TARGETDIR/i386-mingw32/sys-include
300 fi
301
302 CC=cc
303 if [ `uname` = "Darwin" ]; then
304         #GCC_OPTIONS="$GCC_OPTIONS --enable-threads=posix"
305
306         # generally the OS X compiler can create x64 binaries.
307         # Per default it generated i386 binaries in 10.5 and x64
308         # binaries in 10.6 (even if the kernel is 32bit)
309         # For some weird reason, 10.5 autodetects an ABI=64 though
310         # so we're setting the ABI explicitly here.
311         if [ `sysctl -n hw.optional.x86_64` -eq 1 ]; then
312                 OPTIONS="ABI=64"
313         else
314                 OPTIONS="ABI=32"
315         fi
316
317         # In Xcode 4 the default compiler was switched to gcc-llvm.
318         # However, this compiler fails to compile gcc 4.6.x. As a
319         # workaround it's possible to compile gcc with gcc-4.2 or
320         # clang.
321         if $CC -v 2>&1 | grep -q LLVM; then
322                 CC=clang
323         fi
324 fi
325
326 mkdir -p build-gmp build-mpfr build-mpc build-libelf build-binutils \
327                 build-gcc build-python build-expat
328 if [ $SKIPGDB -eq 0 ]; then
329         mkdir -p build-gdb
330 fi
331 if [ -f build-gmp/.success ]; then
332         printf "Skipping GMP as it is already built\n"
333 else
334 printf "Building GMP ${GMP_VERSION} ... "
335 (
336         cd build-gmp
337         rm -f .failed
338         ../${GMP_DIR}/configure --disable-shared --prefix=$TARGETDIR $OPTIONS \
339                 || touch .failed
340         $MAKE $JOBS || touch .failed
341         $MAKE install DESTDIR=$DESTDIR || touch .failed
342         if [ ! -f .failed ]; then touch .success; fi
343 ) > build-gmp/crossgcc-build.log 2>&1
344 test -r build-gmp/.failed && printf "${RED}failed${NC}\n" || \
345         printf "${green}ok${NC}\n"
346 test -r build-gmp/.failed && exit 1
347 fi
348
349 #if [ "$DESTDIR" != "" -a ! -x $TARGETDIR ]; then
350 #       # create compat link
351 #       ln -s $DESTDIR$TARGETDIR $TARGETDIR
352 #fi
353
354 # Now set CFLAGS to match GMP CFLAGS but strip out -pedantic
355 # as GCC 4.6.x fails if it's there.
356 HOSTCFLAGS=`grep __GMP_CFLAGS $DESTDIR$TARGETDIR/include/gmp.h |cut -d\" -f2 |\
357             sed s,-pedantic,,`
358
359 if [ -f build-mpfr/.success ]; then
360         printf "Skipping MPFR as it is already built\n"
361 else
362 printf "Building MPFR ${MPFR_VERSION} ... "
363 (
364         test `uname` = "Darwin" && CFLAGS="$CFLAGS -force_cpusubtype_ALL"
365         cd build-mpfr
366         rm -f .failed
367         ../${MPFR_DIR}/configure --disable-shared --prefix=$TARGETDIR \
368                 --infodir=$TARGETDIR/info \
369                 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \
370                 touch .failed
371         $MAKE $JOBS || touch .failed
372         $MAKE install DESTDIR=$DESTDIR || touch .failed
373
374         # work around build problem of libgmp.la
375         if [ "$DESTDIR" != "" ]; then
376             perl -pi -e "s,$DESTDIR,," $DESTDIR$TARGETDIR/libgmp.la
377         fi
378
379         if [ ! -f .failed ]; then touch .success; fi
380 ) > build-mpfr/crossgcc-build.log 2>&1
381 test -r build-mpfr/.failed && printf "${RED}failed${NC}\n" || \
382              printf "${green}ok${NC}\n"
383 test -r build-mpfr/.failed && exit 1
384 fi
385
386 if [ -f build-mpc/.success ]; then
387         printf "Skipping MPC as it is already built\n"
388 else
389 printf "Building MPC ${MPC_VERSION} ... "
390 (
391         #test `uname` = "Darwin" && CFLAGS="$CFLAGS -force_cpusubtype_ALL"
392         cd build-mpc
393         rm -f .failed
394         ../${MPC_DIR}/configure --disable-shared --prefix=$TARGETDIR \
395                 --infodir=$TARGETDIR/info --with-mpfr=$DESTDIR$TARGETDIR \
396                 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \
397                 touch .failed
398         $MAKE $JOBS || touch .failed
399         $MAKE install DESTDIR=$DESTDIR || touch .failed
400
401         if [ ! -f .failed ]; then touch .success; fi
402 ) > build-mpc/crossgcc-build.log 2>&1
403 test -r build-mpc/.failed && printf "${RED}failed${NC}\n" || \
404              printf "${green}ok${NC}\n"
405 test -r build-mpc/.failed && exit 1
406 fi
407
408 if [ -f build-libelf/.success ]; then
409         printf "Skipping libelf as it is already built\n"
410 else
411 printf "Building libelf ${LIBELF_VERSION} ... "
412 (
413         cd build-libelf
414         rm -f .failed
415         echo "$HOSTCFLAGS"
416         CFLAGS="$HOSTCFLAGS" libelf_cv_elf_h_works=no \
417         ../${LIBELF_DIR}/configure --disable-shared --prefix=$TARGETDIR \
418                 --infodir=$TARGETDIR/info CFLAGS="$HOSTCFLAGS" || touch .failed
419         $MAKE $JOBS || touch .failed
420         $MAKE install DESTDIR=$DESTDIR || touch .failed
421
422         if [ ! -f .failed ]; then touch .success; fi
423 ) > build-libelf/crossgcc-build.log 2>&1
424 test -r build-libelf/.failed && printf "${RED}failed${NC}\n" || \
425              printf "${green}ok${NC}\n"
426 test -r build-libelf/.failed && exit 1
427 fi
428
429 if [ -f build-binutils/.success ]; then
430         printf "Skipping binutils as it is already built\n"
431 else
432 printf "Building binutils ${BINUTILS_VERSION} ... "
433 (
434         # What a pain: binutils don't come with configure
435         # script anymore. Create it:
436         cd binutils-${BINUTILS_VERSION}/
437         autoconf
438         cd ..
439         # Now build binutils
440         cd build-binutils
441         rm -f .failed
442         ../binutils-${BINUTILS_VERSION}/configure --prefix=$TARGETDIR \
443                 --target=${TARGETARCH} --disable-werror --disable-nls \
444                 $USE_GOLD CFLAGS="$HOSTCFLAGS" || touch .failed
445         $MAKE $JOBS || touch .failed
446         $MAKE install DESTDIR=$DESTDIR || touch .failed
447         if [ ! -f .failed ]; then touch .success; fi
448 ) > build-binutils/crossgcc-build.log 2>&1
449 test -r build-binutils/.failed && printf "${RED}failed${NC}\n" || \
450              printf "${green}ok${NC}\n"
451 test -r build-binutils/.failed && exit 1
452 fi
453
454 if [ -f build-gcc/.success ]; then
455         printf "Skipping GCC as it is already built\n"
456 else
457 printf "Building GCC ${GCC_VERSION} ... "
458 (
459         # Even worse than binutils: GCC does not come with configure
460         # script anymore, but also enforces an obsolete autoconf version
461         # to create it. This is a poster child of how autotools help make
462         # software portable.
463         cd gcc-${GCC_VERSION}
464         sed '/dnl Ensure exactly this Autoconf version is used/d' \
465                 config/override.m4 > config/override.m4.new
466         autoconf_version=`autoconf -V | grep "autoconf" | tr ' ' '\n' | tail -1`
467         sed "s/${GCC_AUTOCONF_VERSION}/${autoconf_version}/g" \
468                 config/override.m4.new > config/override.m4
469         autoconf
470         cd ..
471         # Now, finally, we can build gcc:
472         cd build-gcc
473         export PATH=$PATH:$DESTDIR$TARGETDIR/bin
474         rm -f .failed
475         # GCC does not honour HOSTCFLAGS at all. CFLAGS are used for
476         # both target and host object files. This is pretty misdesigned.
477         # There's a work-around called CFLAGS_FOR_BUILD and CFLAGS_FOR_TARGET
478         # but it does not seem to work properly. At least the host library
479         # libiberty is not compiled with CFLAGS_FOR_BUILD.
480         CC="$CC" CFLAGS_FOR_TARGET="-O2" CFLAGS="$HOSTCFLAGS" \
481                 CFLAGS_FOR_BUILD="$HOSTCFLAGS" ../gcc-${GCC_VERSION}/configure \
482                 --prefix=$TARGETDIR --libexecdir=$TARGETDIR/lib \
483                 --target=${TARGETARCH} --disable-werror --disable-shared \
484                 --disable-libssp --disable-bootstrap --disable-nls \
485                 --disable-libquadmath \
486                 $GCC_OPTIONS --enable-languages="c" $USE_GOLD \
487                 --with-gmp=$DESTDIR$TARGETDIR --with-mpfr=$DESTDIR$TARGETDIR \
488                 --with-mpc=$DESTDIR$TARGETDIR --with-libelf=$DESTDIR$TARGETDIR \
489                 --with-pkgversion="coreboot toolchain v$CROSSGCC_VERSION $CROSSGCC_DATE" \
490                 || touch .failed
491         $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" || touch .failed
492         $MAKE install DESTDIR=$DESTDIR || touch .failed
493         if [ ! -f .failed ]; then touch .success; fi
494 ) > build-gcc/crossgcc-build.log 2>&1
495 test -r build-gcc/.failed && printf "${RED}failed${NC}\n" || \
496              printf "${green}ok${NC}\n"
497 test -r build-gcc/.failed && exit 1
498 fi
499
500 if [ -f build-expat/.success ]; then
501         printf "Skipping Expat as it is already built\n"
502 elif [ $SKIPGDB -eq 1 ]; then
503         printf "Skipping Expat as requested by command line (skip GDB)\n"
504 else
505 printf "Building Expat ${EXPAT_VERSION} ... "
506 (
507         cd build-expat
508         export PATH=$PATH:$DESTDIR$TARGETDIR/bin
509         rm -f .failed
510         CFLAGS="$HOSTCFLAGS" ../${EXPAT_DIR}/configure --disable-shared \
511                 --prefix=$TARGETDIR --target=${TARGETARCH} || touch .failed
512         $MAKE || touch .failed
513         $MAKE install DESTDIR=$DESTDIR || touch .failed
514         if [ ! -f .failed ]; then touch .success; fi
515 ) &> build-expat/crossgcc-build.log
516 test -r build-expat/.failed && printf "${RED}failed${NC}\n" || \
517              printf "${green}ok${NC}\n"
518 test -r build-expat/.failed && exit 1
519 fi
520
521
522 if [ -f build-python/.success ]; then
523         printf "Skipping Python as it is already built\n"
524 elif [ $SKIPGDB -eq 1 ]; then
525         printf "Skipping Python as requested by command line (skip GDB)\n"
526 else
527 printf "Building Python ${PYTHON_VERSION} ... "
528 (
529         cd build-python
530         export PATH=$PATH:$DESTDIR$TARGETDIR/bin
531         rm -f .failed
532         CFLAGS="$HOSTCFLAGS" ../${PYTHON_DIR}/configure --prefix=$TARGETDIR \
533                 --target=${TARGETARCH} || touch .failed
534         $MAKE $JOBS || touch .failed
535         $MAKE install DESTDIR=$DESTDIR || touch .failed
536         if [ ! -f .failed ]; then touch .success; fi
537 ) &> build-gdb/crossgcc-build.log
538 test -r build-python/.failed && printf "${RED}failed${NC}\n" || \
539              printf "${green}ok${NC}\n"
540 test -r build-python/.failed && exit 1
541 fi
542
543
544 if [ -f build-gdb/.success ]; then
545         printf "Skipping GDB as it is already built\n"
546 elif [ $SKIPGDB -eq 1 ]; then
547         printf "Skipping GDB as requested by command line\n"
548 else
549 printf "Building GDB ${GDB_VERSION} ... "
550 (
551         cd build-gdb
552         export PATH=$PATH:$DESTDIR$TARGETDIR/bin
553         export PYTHONHOME=$DESTDIR$TARGETDIR
554         rm -f .failed
555         LDFLAGS="-Wl,-rpath,\$\$ORIGIN/../lib/ -L$DESTDIR$TARGETDIR/lib \
556                  -lpthread -ldl -lutil" \
557         CFLAGS="$HOSTCFLAGS -I$DESTDIR$TARGETDIR/include" \
558         ../gdb-${GDB_VERSION}/configure --prefix=$TARGETDIR \
559                 --target=${TARGETARCH} --disable-werror --disable-nls
560         $MAKE $JOBS || touch .failed
561         $MAKE install DESTDIR=$DESTDIR || touch .failed
562         if [ ! -f .failed ]; then touch .success; fi
563 ) > build-gdb/crossgcc-build.log 2>&1
564 test -r build-gdb/.failed && printf "${RED}failed${NC}\n" || \
565              printf "${green}ok${NC}\n"
566 test -r build-gdb/.failed && exit 1
567 fi
568
569 if [ -f $IASL_DIR/compiler/.success ]; then
570         printf "Skipping IASL as it is already built\n"
571 else
572 printf "Building IASL ${IASL_VERSION} ... "
573 (
574         cd $IASL_DIR/compiler
575         export PATH=$PATH:$DESTDIR$TARGETDIR/bin
576         rm -f .failed
577         CFLAGS="$HOSTCFLAGS"
578         $MAKE || touch .failed
579         rm -f $DESTDIR$TARGETDIR/bin/iasl || touch .failed
580         cp iasl $DESTDIR$TARGETDIR/bin || touch .failed
581         if [ ! -f .failed ]; then touch .success; fi
582 ) > $IASL_DIR/compiler/crossgcc-build.log 2>&1
583 test -r $IASL_DIR/compiler/.failed && printf "${RED}failed${NC}\n" || \
584              printf "${green}ok${NC}\n"
585 test -r $IASL_DIR/compiler/.failed && exit 1
586 fi
587
588 if [ $SAVETEMPS -eq 0 ]; then
589         printf "Cleaning up... "
590         rm -rf ${GMP_DIR} build-gmp
591         rm -rf ${MPFR_DIR} build-mpfr
592         rm -rf ${MPC_DIR} build-mpc
593         rm -rf ${LIBELF_DIR} build-libelf
594         rm -rf ${BINUTILS_DIR} build-binutils
595         rm -rf ${GCC_DIR} build-gcc
596         rm -rf ${GDB_DIR} build-gdb
597         rm -rf ${EXPAT_DIR} build-expat
598         rm -rf ${PYTHON_DIR} build-python
599         rm -rf ${IASL_DIR}
600         printf "${green}ok${NC}\n"
601 else
602         printf "Leaving temporary files around... ${green}ok${NC}\n"
603 fi
604
605 printf "\n${green}You can now run your $TARGETARCH cross toolchain from $TARGETDIR.${NC}\n"
606
607